﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MainApp.Controls
{
	public partial class Image_Insert_Select_Control : UserControl
	{
		public Image_Insert_Select_Control()
		{
			InitializeComponent();

			InitInstance();
		}

		private void InitInstance()
		{
			pictureBox.SizeMode = PictureBoxSizeMode.Zoom;

			if (!AdoClient.Instance.SetConnection("peacecloud.synology.me,21433", "Study", "study", "Study123$"))
			{
				MessageBox.Show("Cannot access database.");
				return;
			}
		}

		private void uploadButton_Click(object sender, EventArgs e)
		{
			OpenFileDialog dlg = new OpenFileDialog();
			if (dlg.ShowDialog() != DialogResult.OK)
				return;

			Image img = Image.FromFile(dlg.FileName);
			pictureBox.Image = img;

			byte[] imgByteArray = Util.ImageToByteArray(img);

			string paramedSql = "INSERT INTO IMAGE (name, image, createdAt) VALUES (@name, @image, @createdAt)";
			SqlParameter[] sqlParams = new SqlParameter[3];

			sqlParams[0] = new SqlParameter("@name", SqlDbType.NVarChar);
			string name = Guid.NewGuid().ToString();
			nameLabel.Text = name;
			sqlParams[0].Value = name;

			sqlParams[1] = new SqlParameter("@image", SqlDbType.VarBinary);
			sqlParams[1].Value = imgByteArray;

			sqlParams[2] = new SqlParameter("@createdAt", SqlDbType.DateTime);
			sqlParams[2].Value = DateTime.Now;

			AdoClient.Instance.NonQuery(paramedSql, sqlParams);

			GC.Collect();
		}

		private void selectButton_Click(object sender, EventArgs e)
		{
			int idx = -1;
			if (!int.TryParse(indexTextbox.Text, out idx))
			{
				MessageBox.Show("Invalid index");
				return;
			}

			DataSet dataSet = AdoClient.Instance.Query($"SELECT * FROM IMAGE WHERE idx = {idx}");
			if (dataSet == null || 
				dataSet.Tables == null || dataSet.Tables.Count < 1 ||
				dataSet.Tables[0].Rows == null || dataSet.Tables[0].Rows.Count < 1 ||
				dataSet.Tables[0].Rows[0].ItemArray == null)
			{
				MessageBox.Show("No matched data");
				return;
			}

			object[] selectedObj = dataSet.Tables[0].Rows[0].ItemArray;

			string name = (string)selectedObj[1];
			DateTime createdAt = (DateTime)selectedObj[3];
			nameLabel.Text = $"{name}@[{createdAt.ToString("yyyy-MM-dd HH:mm:ss")}]";

			byte[] imgByteArray = (byte[])selectedObj[2];

			Image img = Util.ByteToImage(imgByteArray);
			pictureBox.Image = img;

			GC.Collect();
		}

		private void saveButton_Click(object sender, EventArgs e)
		{
			if (pictureBox.Image == null)
			{
				MessageBox.Show("No Image to save");
				return;
			}

			SaveFileDialog dlg = new SaveFileDialog();
			dlg.Filter = "png type|*.png|bmp type|*.bmp|jpg type|*.jpg";
			if (dlg.ShowDialog() != DialogResult.OK)
				return;

			ImageFormat imageFormat = null;
			switch (dlg.FilterIndex)
			{
				case 1:
					imageFormat = ImageFormat.Png;
					break;
				case 2:
					imageFormat = ImageFormat.Bmp;
					break;
				case 3:
					imageFormat = ImageFormat.Jpeg;
					break;
				default:
					MessageBox.Show("Invalid Type");
					break;
			}

			if (imageFormat == null)
			{
				return;
			}

			Util.SaveImage(dlg.FileName, pictureBox.Image, imageFormat);

			GC.Collect();
		}

		private void indexTextbox_KeyUp(object sender, KeyEventArgs e)
		{
			if (e.KeyCode != Keys.Enter)
				return;

			selectButton_Click(sender, e);
		}
	}
}
