﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MainApp.Controls
{
	public partial class Multiple_Query_Control : UserControl
	{
		public Multiple_Query_Control()
		{
			InitializeComponent();
			InitInstance();
		}

		private void InitInstance()
		{
			if (!AdoClient.Instance.SetConnection("peacecloud.synology.me,21433", "Study", "study", "Study123$"))
			{
				MessageBox.Show("Cannot access database.");
				return;
			}

			DoWork();
		}

		private void BindTableToGridView(DataGridView gridView, DataTable table)
		{
			gridView.SuspendLayout();
			gridView.DataSource = table;
			gridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
			gridView.ResumeLayout();
		}

		private void DoWork()
		{
			string sql = @"SELECT * FROM EMPLOYEE;
						   SELECT E.ENAME, E.JOB, M.ENAME AS MANAGER, D.DNAME, D.LOC FROM EMPLOYEE AS E
							LEFT JOIN EMPLOYEE AS M ON E.MANAGER = M.ENO
							LEFT JOIN DEPARTMENT AS D ON E.DNO = D.DNO";
			
			DataSet dataSet = AdoClient.Instance.Query(sql);

			BindTableToGridView(topGridView, dataSet.Tables[0]);
			BindTableToGridView(bottomGridView, dataSet.Tables[1]);
		}
	}
}
