﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MainApp.Controls
{
	public partial class Sql_Param_Control : UserControl
	{
		public Sql_Param_Control(string job, DateTime hiredate)
		{
			InitializeComponent();

			InitInstance(job, hiredate);
		}

		private void InitInstance(string job, DateTime hiredate)
		{
			if (!AdoClient.Instance.SetConnection("peacecloud.synology.me,21433", "Study", "study", "Study123$"))
			{
				MessageBox.Show("Cannot access database.");
				return;
			}

			DoWork(job, hiredate);
		}

		private void BindTableToGridView(DataTable table)
		{
			mainGridView.SuspendLayout();
			mainGridView.DataSource = table;
			mainGridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
			mainGridView.ResumeLayout();
		}

		private void DoWork(string job, DateTime hiredate)
		{
			string paramedSql = "SELECT * FROM EMPLOYEE WHERE JOB = @job AND HIREDATE >= @hiredate";
			SqlParameter[] sqlParams = new SqlParameter[]
			{
				new SqlParameter("@job", SqlDbType.VarChar),
				new SqlParameter("@hiredate", SqlDbType.Date)
			};
			sqlParams[0].Value = job;
			sqlParams[1].Value = hiredate;
			

			DataSet dataSet = AdoClient.Instance.Query(paramedSql, sqlParams);
			BindTableToGridView(dataSet.Tables[0]);
		}
	}
}
