﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Text;

namespace MainApp
{
	class Util
	{
		public static byte[] ImageToByteArray(Image image)
		{
			using (MemoryStream ms = new MemoryStream())
			{
				image.Save(ms, image.RawFormat);
				return ms.ToArray();
			}
		}

		public static Bitmap ByteToImage(byte[] imgByteArray)
		{
			using (MemoryStream ms = new MemoryStream(imgByteArray))
			{
				Bitmap img = Image.FromStream(ms) as Bitmap;
				return img;
			}
		}

		public static void SaveImage(string fileName, Image img, ImageFormat format)
		{
			using (Image saveImage = new Bitmap(img))
			{
				saveImage.Save(fileName, format);
			}
		}
	}
}
